"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiDataFilterGroup = void 0;
var _common_1 = require("@common");
var ApiDataFilterGroup = (function () {
    function ApiDataFilterGroup(filters, filterOperator, groupOperator) {
        if (filterOperator === void 0) { filterOperator = _common_1.FilterOperator.and; }
        if (groupOperator === void 0) { groupOperator = _common_1.FilterOperator.and; }
        this.filters = filters;
        this.filterOperator = filterOperator;
        this.groupOperator = groupOperator;
        Object.freeze(this);
    }
    ApiDataFilterGroup.fromApiTableFilter = function (filter) {
        return new ApiDataFilterGroup([filter]);
    };
    ApiDataFilterGroup.fromColumnValues = function (values, columnName, filterOperator) {
        if (filterOperator === void 0) { filterOperator = _common_1.FilterOperator.or; }
        return new ApiDataFilterGroup(values.map(function (value) { return new _common_1.ApiDataFilter(value, _common_1.EQUAL, columnName); }), filterOperator);
    };
    ApiDataFilterGroup.fromTimeFrame = function (columnName, startDate, endDate) {
        var filters = [];
        if (startDate) {
            filters.push(new _common_1.ApiDataFilter(startDate.toISOString(), _common_1.GREATER_THAN, columnName));
        }
        if (endDate) {
            filters.push(new _common_1.ApiDataFilter(endDate.toISOString(), _common_1.LESS_THAN, columnName));
        }
        return new ApiDataFilterGroup(filters);
    };
    return ApiDataFilterGroup;
}());
exports.ApiDataFilterGroup = ApiDataFilterGroup;
//# sourceMappingURL=api-data-filter-group.js.map