import { ApiDataFilterGroup, OrderFilter } from '@common';
import FormData from 'form-data';
export declare class TableDataFormDataBuilder {
    private _formDataFactory;
    private _formParts;
    constructor(_formDataFactory: () => FormData, _formParts?: Record<string, string | number>);
    withColumnGroups(groups: Array<string> | undefined): TableDataFormDataBuilder;
    withFilterGroups(groups: Array<ApiDataFilterGroup> | undefined): TableDataFormDataBuilder;
    withPage(page?: number): TableDataFormDataBuilder;
    withPageSize(pageSize?: number): TableDataFormDataBuilder;
    withSortColumn(sortColumn: string | undefined): TableDataFormDataBuilder;
    withSortOrder(sortOrder: OrderFilter | undefined): TableDataFormDataBuilder;
    withDatabase(database: string | undefined): TableDataFormDataBuilder;
    withApplications(applications: Array<string>): TableDataFormDataBuilder;
    withVersions(versions: Array<string>): TableDataFormDataBuilder;
    build(): FormData;
}
