"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEventFromApiResponse = void 0;
function createEventFromApiResponse(event, type) {
    return {
        id: parseInt(event.id),
        action: type,
        createdDate: new Date(event.timestamp),
        subject: {
            initials: getInitialsOrDefault(event),
            email: event.username,
        },
        message: event.message,
    };
}
exports.createEventFromApiResponse = createEventFromApiResponse;
function getInitialsOrDefault(event) {
    var _a, _b;
    if (event.firstName && event.lastName) {
        var firstInitial = event.firstName[0];
        var lastInitial = event.lastName[0];
        return "" + firstInitial + lastInitial;
    }
    return (_b = (_a = event.username) === null || _a === void 0 ? void 0 : _a.substring(0, 2)) !== null && _b !== void 0 ? _b : '';
}
//# sourceMappingURL=create-event-from-api-response.js.map