import { ApiDataFilter, EQUAL, FilterOperator, GREATER_THAN, LESS_THAN } from '@common';
export class ApiDataFilterGroup {
    filters;
    filterOperator;
    groupOperator;
    constructor(filters, filterOperator = FilterOperator.and, groupOperator = FilterOperator.and) {
        this.filters = filters;
        this.filterOperator = filterOperator;
        this.groupOperator = groupOperator;
        Object.freeze(this);
    }
    static fromApiTableFilter(filter) {
        return new ApiDataFilterGroup([filter]);
    }
    static fromColumnValues(values, columnName, filterOperator = FilterOperator.or) {
        return new ApiDataFilterGroup(values.map(value => new ApiDataFilter(value, EQUAL, columnName)), filterOperator);
    }
    static fromTimeFrame(columnName, startDate, endDate) {
        const filters = [];
        if (startDate) {
            filters.push(new ApiDataFilter(startDate.toISOString(), GREATER_THAN, columnName));
        }
        if (endDate) {
            filters.push(new ApiDataFilter(endDate.toISOString(), LESS_THAN, columnName));
        }
        return new ApiDataFilterGroup(filters);
    }
}
//# sourceMappingURL=api-data-filter-group.js.map