import { Module, Register, ThreadCollection } from '@crash';
import { ModuleResponseObject } from '../module/module';
export interface AdditionalInfoConstructorOptions {
    os: string;
    debuggerOutput: string;
    registers: Array<Register>;
    modules: Array<Module>;
    threads: Array<ThreadCollection>;
}
export interface AdditionalInfoResponseObject {
    os: string;
    process: {
        DebugOutput: {
            DbgEngOutput: string;
        };
        exception: {
            registers: Record<string, string>;
        };
        threads: {
            thread: ThreadResponseObject | Array<ThreadResponseObject>;
        };
        modules: {
            module: Array<ModuleResponseObject>;
        };
    };
}
export interface FrameResponseObject {
    file: string;
    symbol: string;
    line: string;
    arguments: Array<unknown>;
    locals: Array<unknown>;
}
export interface ThreadResponseObject {
    '@attribute': {
        id: string;
        current: string;
    };
    frame: FrameResponseObject | Array<FrameResponseObject>;
}
export declare class AdditionalInfo implements AdditionalInfoConstructorOptions {
    os: string;
    debuggerOutput: string;
    registers: Array<Register>;
    modules: Array<Module>;
    threads: Array<ThreadCollection>;
    constructor(options: AdditionalInfoConstructorOptions);
    static fromRawResponse(response: AdditionalInfoResponseObject | undefined): AdditionalInfo;
}
